import 'package:flutter/material.dart';
import 'package:layout_form_builder/datalayer/bean/eform_cache.dart';
import 'package:layout_form_builder/datalayer/constant/eform_properties.dart';
import '../layout_form_renderer.dart';
import '../util.dart';

class FullSizeColumn extends StatefulWidget {
  final Map<String, dynamic>? fieldProp;
  final String? id;
  final Widget child;
  final String? label;
  final bool? visible;
  final bool? compulsory;

  FullSizeColumn(
      {Key? key,
      this.fieldProp,
      this.id,
      this.label,
      this.visible,
      this.compulsory,
      required this.child})
      : super(key: key);

  @override
  _FullSizeColumnState createState() => _FullSizeColumnState();
}

class _FullSizeColumnState extends State<FullSizeColumn> {
  @override
  Widget build(BuildContext context) {
    Map<String, dynamic>? fp = widget.fieldProp;
    bool visible = widget.visible ?? false;
    bool compulsory = widget.compulsory ?? false;
    String label = widget.label ?? "";

    if (fp != null) {
      visible = EFormCache.getFormFieldPropBool(context, fp, EFormProperties.PROP_INPUT_VISIBLE, fromValidator: false, defaultValue: true);
      compulsory = EFormCache.getFormFieldPropBool(context, fp, EFormProperties.PROP_COMPULSORY, fromValidator: false, defaultValue: false);
      label = EFormCache.getFormFieldPropString(context, fp, EFormProperties.PROP_INPUT_LABEL, fromValidator: false) ?? "";
    }

    return Visibility(
        visible: visible,
        child: Column(
          mainAxisSize: MainAxisSize.min,
          crossAxisAlignment: CrossAxisAlignment.start,
          children: [
            RichText(
                text: TextSpan(
                    text: label,
                    style: TextStyle(
                        fontFamily: 'Lato',
                        fontSize: 16,
                        fontWeight: FontWeight.normal,
                        color: Colors.black),
                    children: [
                  TextSpan(
                      text: compulsory ? '*' : '',
                      style: TextStyle(
                          fontFamily: 'Lato',
                          fontSize: 16,
                          fontWeight: FontWeight.normal,
                          color: HexColor.fromHex('ee1c25')))
                ])),
            SizedBox(height: 8.0),
            widget.child,
            SizedBox(height: 12.0)
          ],
        ));
  }
}
