import 'package:flutter/material.dart';

import '../util.dart';

class PartialSizeColumn extends StatefulWidget {
  final String id;
  final Widget child;
  final String label;
  final bool visible;
  final int flex;
  final bool compulsory;

  PartialSizeColumn(
      {required this.id,
      required this.label,
      required this.visible,
      required this.flex,
      required this.compulsory,
      required this.child});

  @override
  _PartialSizeColumnState createState() => _PartialSizeColumnState();
}

class _PartialSizeColumnState extends State<PartialSizeColumn> {
  @override
  Widget build(BuildContext context) {
    return Visibility(
        visible: widget.visible,
        child: Flexible(
            flex: widget.flex,
            child: Column(
              mainAxisSize: MainAxisSize.min,
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [
                RichText(
                    text: TextSpan(
                        text: widget.label,
                        style: TextStyle(
                            fontFamily: 'Lato',
                            fontSize: 16,
                            fontWeight: FontWeight.normal,
                            color: Colors.black),
                        children: [
                      TextSpan(
                          text: widget.compulsory ? '*' : '',
                          style: TextStyle(
                              fontFamily: 'Lato',
                              fontSize: 16,
                              fontWeight: FontWeight.normal,
                              color: HexColor.fromHex('ee1c25')))
                    ])),
                SizedBox(height: 8.0),
                widget.child,
                SizedBox(height: 12.0)
              ],
            )));
  }
}
