import 'package:dynamic_widget/dynamic_widget.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:layout_form_builder/datalayer/bean/eform_cache.dart';
import 'package:layout_form_builder/datalayer/constant/eform_parser.dart';
import 'package:layout_form_builder/datalayer/constant/eform_properties.dart';

class FlexibleParser extends WidgetParser {
  @override
  String get widgetName => EFormWidgetParser.Flexible.value;

  @override
  Widget parse(Map<String, dynamic> map, BuildContext buildContext, ClickListener? listener) {
    final child = EFormCache.fieldDynamic(map, EFormProperties.PROP_CHILD);

    return Flexible(
      flex: EFormCache.fieldInt(map, EFormProperties.PROP_FLEX) ?? 1,
      child: DynamicWidgetBuilder.buildFromMap(child, buildContext, listener)!);
  }

  @override
  Type get widgetType => Flexible;

  @override
  Map<String, dynamic>? export(Widget? widget, BuildContext? buildContext) {
    return Map<String, dynamic>();
  }
}
